ChangeSet 1.1557.49.19, 2004/02/18 13:12:22-08:00, david-b@pacbell.net

[PATCH] USB: usbcore, hub driver enables TT-per-port mode

[USB] hub driver turns on multi-TT mode

This turns on the multi-tt mode in hubs that support it; the Cypress
"TetraHub" products are appearing at retail now, complete with some
of the first Mini-B connectors I've seen shipping.

This will be important for hooking up lots of full speed isochronous
devices (audio, video, etc).


 drivers/usb/core/hub.c |    9 +++++++--
 1 files changed, 7 insertions(+), 2 deletions(-)


diff -Nru a/drivers/usb/core/hub.c b/drivers/usb/core/hub.c
--- a/drivers/usb/core/hub.c	Thu Feb 19 17:21:32 2004
+++ b/drivers/usb/core/hub.c	Thu Feb 19 17:21:32 2004
@@ -405,9 +405,14 @@
 			hub->tt.hub = dev;
 			break;
 		case 2:
-			dev_dbg(hub_dev, "TT per port\n");
+			ret = usb_set_interface(dev, 0, 1);
+			if (ret == 0) {
+				dev_dbg(hub_dev, "TT per port\n");
+				hub->tt.multi = 1;
+			} else
+				dev_err(hub_dev, "Using single TT (err %d)\n",
+					ret);
 			hub->tt.hub = dev;
-			hub->tt.multi = 1;
 			break;
 		default:
 			dev_dbg(hub_dev, "Unrecognized hub protocol %d\n",
